Declare Sub checktick() 
Declare Sub logport(portnum As UInteger, direction As Byte, ByVal value As UByte)
Declare Sub write86(ByVal addr32 as UInteger, ByVal value As Integer)
Declare Sub putmem16(ByVal segment as UInteger, ByVal offset as UInteger, ByVal value as UInteger)
Declare Sub putreg16(ByVal regnum As Byte, ByVal value as UShort)
Declare Sub putreg8(ByVal regnum As Byte, ByVal value as UInteger)
Declare Sub putsegreg(ByVal regnum As Byte, ByVal value as UInteger)
Declare Sub StepIP(stepcount As Byte)
Declare Function getreg8(ByVal regnum As Byte) as UInteger
Declare Function getreg16(ByVal regnum As Byte) as UShort
Declare Sub push(ByVal pushval as UInteger)
Declare Function getea(ByVal rmval as UInteger) as ULong
Declare Sub modregrm()
Declare Sub writerm16(ByVal rmval as UInteger, ByVal value as UInteger)
Declare Sub writerm8(ByVal rmval as UInteger, ByVal value as UInteger)
Declare Sub reljump(ByVal value as UInteger)
Declare Sub decodeflagsword(ByVal value as UInteger)
Declare Sub reset86()
Declare Sub exec86()
declare sub VidRefresh()
Declare Sub OpenLogfile()
Declare Sub WriteLogExec()
Declare Sub WriteLog()
Declare Sub InsertDisk(ByVal DriveNum as LongInt, DiskFileName As String)
Declare Sub EjectDisk(ByVal DriveNum as LongInt)
Declare Sub ReadDisk(ByVal DriveNum as uLong, ByVal DstSeg as ulong, ByVal DstOff as ulong, ByVal Cyl as ulong, ByVal Sect as ulong, ByVal Head as LongInt, ByVal SectCount as ulong)
Declare Function BootDrive(ByVal DriveNum as LongInt) as LongInt
Declare Sub DiskHandler()
Declare Sub doshandler()
Declare Sub flag_szp8(ByVal value as LongInt)
Declare Sub flag_szp16(ByVal value as LongInt)
Declare Sub flag_log8(ByVal value as LongInt)
Declare Sub flag_log16(ByVal value as LongInt)
Declare Sub flag_add8(ByVal value as LongInt)
Declare Sub flag_add16(ByVal value as LongInt)
Declare Sub flag_sub8(ByVal value as LongInt)
Declare Sub flag_sub16(ByVal value as LongInt)
Declare Sub op_grp1(ByVal word)
Declare Sub op_grp2(ByVal word)
Declare Sub op_grp3(ByVal word)
Declare Sub op_grp5()
Declare Sub intcall86(ByVal intnum As Integer)
Declare Sub BootHandler()
Declare Sub EmuPrint(Message As String)
Declare Sub KeyHandler()
Declare Sub op_adc(ByVal word)
Declare Sub op_add(ByVal word)
Declare Sub op_and(ByVal word)
Declare Sub op_cmp(ByVal word)
Declare Sub op_test(ByVal word)
Declare Sub op_or(ByVal word)
Declare Sub op_sbb(ByVal word)
Declare Sub op_sub(ByVal word)
Declare Sub op_xor(ByVal word)
Declare Sub InitOplist()
Declare Sub VidInterrupt()
Declare Sub InitCGA()
Declare Sub InitVGA()
Declare Sub CheckCursorBounds()

Type dosfiletype
	filename As String
End Type

Dim Shared clocksafe As Byte
Dim Shared dodisasm As Byte
Dim Shared dosfile(100) As dosfiletype
Dim Shared portlog As byte
Dim Shared scrmode As Integer
Dim Shared StartedYet As Byte
Dim Shared Shutdown As Byte
Dim Shared Running As Byte
Dim Shared RAM(1048576) As UByte
Dim Shared ReadOnly(1048576) As Byte
Dim Shared Parity(255) As UByte
Dim Shared Oplist(255) As String
Dim Shared FontCGA(255, 7, 15) As UByte
Dim Shared PaletteCGA(15) As UInteger
Dim Shared drawscreen(2, 639, 399) As UByte
Dim Shared vidmode As UByte
Dim Shared cgabg As UByte
Const As UInteger videobase = &hb8000
Dim Shared cursx, cursy, cols, rows, blankattr As UInteger
Dim Shared UpdatedScreen As Byte
Dim Shared lasttimer As Single

Dim Shared al, ah, bl, bh, cl, ch, dl, dh, opcode As UByte
Dim Shared sp, bp, si, di, cs, ds, ss, es, ip, useseg As UShort
Dim Shared cf, pf, af, zf, sf, tf, ifl, df, of As UByte
Dim Shared mode, reg, rm, oper1, oper2 As UShort
Dim Shared Disp, result as LongInt
Dim Shared savecs, saveip, segoverride, reptype as UInteger
Dim Shared totalexec, execloops as LongInt
Dim Shared temp1, temp2, temp3, temp4, temp5 as LongInt
Const ax = 0
Const cx = 1
Const dx = 2
Const bx = 3
Const CrLf As String = Chr$(13)+Chr$(10)
Dim Shared outputlog As Integer

Dim Shared keytmp$
Dim Shared KeyBuffer(15) As UInteger
Dim Shared KeyBufferPos As UInteger

Type typeDrive
    DiskFile As String
    Cylinders as LongInt
    Sectors as LongInt
    Heads as LongInt
    Inserted As Byte
End Type

Dim Shared Disk(&H83) As typeDrive
Dim Shared SectorBuffer(&H83) As String * 512

Dim Shared TraceLog As Byte
Dim Shared MemViewSeg, MemViewOff As uinteger

Sub MsgBox(msg As String)
	print "MSGBOX: " + msg
End Sub

Sub GrabKey()
	keytmp$ = InKey$
	If keytmp$ = Chr$(27) Then running = 0: shutdown = 1
	If keytmp$ <> "" Then
		If Len(keytmp$)=1 Then
			KeyBuffer(KeyBufferPos) = Asc(keytmp$)
		Else
			keybuffer(keybufferpos) = Asc(Left$(keytmp$,1)) + Asc(Right$(keytmp$,1))*256
			If Asc(Left$(keytmp$,1))=255 Then keybuffer(keybufferpos) = keybuffer(keybufferpos) And &hFF00
		End If
		KeyBufferPos = KeyBufferPos + 1
	EndIf
End Sub

Sub logport(portnum As UInteger, direction As Byte, ByVal value As UByte)
	If portlog = 0 Then Exit Sub
	If direction = 1 Then Print #6, "OUT "; Else Print #6, " IN ";
	Print #6, Hex$(portnum) + ": ";
	If direction = 1 Then Print #6, Hex$(value) + " (dec. " + Str$(value) + ")" Else Print #6, ""
End Sub

Sub checktick()
	Dim curtimer As Single
	curtimer = Timer
	If curtimer - lasttimer >= 0.054 Then 'this is crude, but at least it will run the interrupt periodically
		If clocksafe = 1 Then intcall86 8
		lasttimer = curtimer
	End If
End Sub
