Sub op_grp1(ByVal word)
If TraceLog = 1 Then Print #2, "  Reg: " + Hex$(reg)
Select Case reg
    Case 0: 'ADD
        op_add word
    Case 1: 'OR
        op_or word
    Case 2: 'ADC
        op_adc word
    Case 3: 'SBB
        op_sbb word
    Case 4: 'AND
        op_and word
    Case 5: 'SUB
        op_sub word
    Case 6: 'XOR
        op_xor word
    Case 7: 'CMP
        op_cmp word
End Select
End Sub

Sub op_grp2(ByVal word)
Dim signval, bits, maxval, rotation, oldcf as LongInt
If outputlog = 1 Then Print #2, "  Reg: " + Hex$(reg)
If oper2 = 0 Then Exit Sub
If word Then signval = 32768: maxval = 65535: bits = 16 Else signval = 128: maxval = 255: bits = 8
Select Case reg
    Case 0 'ROL
        temp1 = (oper1 Shl (oper2 And (bits-1))) Or (oper1 Shr (bits - (oper2 And (bits-1))))
        cf = temp1 And 1
        of = ((temp1 Shr (bits-1)) Xor temp1) And 1
        
    Case 1 'ROR
    	  temp1 = (oper1 Shr (oper2 And (bits-1))) Or (oper1 Shl (bits - (oper2 And (bits-1))))
    	  cf = ((temp1 And signval) \ signval) And 1
    	  If oper2 = 1 Then of = (((temp1 Xor oper1) And signval) \ signval) And 1
        
    Case 2 'RCL
    	  oper1 = oper1 Or (cf Shl bits)
        temp1 = (oper1 Shl (oper2 Mod (bits+1))) Or (oper1 Shr ((bits+1) - (oper2 Mod (bits+1))))
        cf = ((temp1 and (maxval+1)) \ (maxval+1)) And 1
        of = ((((temp1 Shr 1) Xor temp1) And signval) \ signval) And 1
        
    Case 3 'RCR
    	  oper1 = oper1 Or (cf Shl bits)
    	  temp1 = (oper1 Shr (oper2 Mod (bits+1))) Or (oper1 Shl ((bits+1) - (oper2 Mod (bits+1))))
    	  cf = ((temp1 And (maxval+1)) \ (maxval+1)) And 1
    	  If oper1 = 1 Then of = (((temp1 Xor oper1) And signval) \ signval) And 1

	 Case 4, 6 'SHL/SAL
		  If (oper2 > bits) Then temp1 = 0 Else temp1 = oper1 Shl oper2
		  If word Then flag_szp16 temp1 Else flag_szp8 temp1
		  cf = ((temp1 And (maxval+1)) \ (maxval+1)) And 1
		  of = ((((temp1 Shr 1) Xor temp1) And signval) \ signval) And 1

	 Case 5 'SHR
	 	  If (oper2 > bits) Then temp1 = 0 Else temp1 = (oper1 Shr (oper2 - 1))
	 	  cf = temp1 And 1
	 	  temp1 = temp1 Shr 1
	 	  If word Then flag_szp16 temp1 Else flag_szp8 temp1
	 	  of = ((((temp1 Shl 1) Xor temp1) And signval) \ signval) And 1

	 Case 7 'SAR
	 	  If word Then temp1 = &hFFFF0000& Else temp1 = &hFF00&
        If (oper1 And signval) = signval Then oper1 = oper1 Or temp1
        If (oper2 >= bits) Then temp1 = oper1 Shr (bits - 1) Else temp1 = oper1 Shr (oper2-1)
        'temp1 = oper1 Shr temp1
        cf = temp1 And 1
        temp1 = (temp1 Shr 1) And maxval
        If word Then flag_szp16 temp1 Else flag_szp8 temp1
        of = 0
        
    Case Else
        MsgBox Oplist(opcode) + " using reg val" + Str$(reg) + " not supported!"
        Running = 0
End Select
result = temp1 And maxval
End Sub

Sub op_grp3(ByVal word)
If TraceLog = 1 Then Print #2, "  Reg: " + Hex$(reg)
Select Case reg
    Case 0, 1: 'TEST
        If word Then oper2 = getmem16(cs, ip): StepIP 2: op_test 1 Else oper2 = getmem8(cs, ip): StepIP 1: op_test 0
    
    Case 2: 'NOT
        result = Not oper1
        If word Then result = result And 65535 Else result = result And 255
    
    Case 3: 'NEG
    	  If oper1 = 0 Then cf = 0 Else cf = 1
        result = (Not oper1) + 1
        If word Then result = result And 65535: flag_sub16 result Else result = result And 255: flag_sub8 result
    
    Case 4: 'MUL
        If word Then
        		temp1 = oper1 * getreg16(ax)
        		putreg16 ax, temp1 And &hFFFF&
        		putreg16 dx, temp1 Shr 16
        		If (temp1 And &hFFFF0000&) Then cf = 1: of = 1 Else cf = 0: of = 0
        		'If temp1 = 0 Then zf = 1 Else zf = 0
        Else
        		temp1 = oper1 * al
        		putreg16 ax, temp1
        		If (temp1 And &hFF00&) Then cf = 1: of = 1 Else cf = 0: of = 0
        		'If temp1 = 0 then zf = 1 Else zf = 0
        End If
        
    Case 5: 'IMUL
        If word Then
        		temp1 = getreg16(ax)
        		temp2 = oper1
        		If (temp1 And &h8000&) = &h8000& Then temp1 = temp1 Or &hFFFF0000&
        		If (temp2 And &h8000&) = &h8000& Then temp2 = temp2 Or &hFFFF0000&
        		temp3 = (temp1 * temp2) And &hFFFFFFFF&
        		putreg16 ax, temp3 And &hFFFF&
        		putreg16 dx, temp3 Shr 16
        		temp3 = temp3 And &hFFFF8000&
        		If (temp3 <> &hFFFF8000&) And (temp3 <> 0) Then cf = 1: of = 1 Else cf = 0: of = 0
        		'If temp3 = 0 then zf = 1 Else zf = 0
        Else
        		temp1 = signed16(oper1) * signed16(al)
        		temp1 = temp1 And &hFFFF&
        		putreg16 ax, temp1
        		temp1 = temp1 And &hFF80&
        		If (Not (temp1 = &hFF80&)) And (temp1 <> 0) Then cf = 1: of = 1 Else cf = 0: of = 0
        		'If temp1 = 0 Then zf = 1 Else zf = 0
        End If
        
case 6: 'DIV
		if oper1=0 then intcall86 0: exit sub 'division by zero
		if word then
			temp1=(getreg16(dx) shl 16) or getreg16(ax)
			temp2=temp1\oper1
			if (temp2 and &hFFFF0000)>0 then intcall86 0: exit sub 'divide overflow
			putreg16 ax,temp2
			putreg16 dx,temp1 mod oper1
		else
			temp1=getreg16(ax)
			temp2=temp1\oper1
			if (temp2 and &hFFFFFF00)>0 then intcall86 0: exit sub 'divide overflow
			al=temp2
			ah=temp1 mod oper1
		end if

	case 7: 'IDIV
		if oper1=0 then intcall86 0: exit sub 'division by zero
		if word Then
			temp1=(getreg16(dx) Shl 16) or getreg16(ax)
			temp2=temp1\oper1
			if (temp2 and &h7FFF0000)>0 then intcall86 0: exit sub 'divide overflow
			putreg16 ax,temp2
			putreg16 dx,temp1 mod oper1
		else
			temp1=getreg16(ax)
			temp2=temp1\oper1
			if (temp2 and &h7FFFFF00)>0 then intcall86 0: exit sub 'divide overflow
			al=temp2
			ah=temp1 mod oper1
		end If
End Select
End Sub

Sub op_grp5()
Select Case reg
    Case 0 'INC Ev
        oper2 = 1
        tempcf = cf: op_add 1: cf = tempcf
        writerm16 rm, result
        
    Case 1 'DEC Ev
        oper2 = 1
        tempcf = cf: op_sub 1: cf = tempcf
        writerm16 rm, result
    
    Case 2 'CALL Ev
        push ip
        ip = oper1
    
    Case 3 'CALL Mp
        push cs: push ip
        temp1 = (useseg * 16) + getea(rm)
        ip = read86(temp1) + read86(temp1 + 1) * 256
        cs = read86(temp1 + 2) + read86(temp1 + 3) * 256
    
    Case 4 'JMP Ev
        ip = oper1
    
    Case 5 'JMP Mp
        temp1 = (useseg * 16) + getea(rm)
        ip = read86(temp1) + read86(temp1 + 1) * 256
        cs = read86(temp1 + 2) + read86(temp1 + 3) * 256

    Case 6 'PUSH Ev
        push oper1

End Select
End Sub
