Sub VidInterrupt()
Dim vidptr, tempcalc as LongInt
UpdatedScreen = 1
Select Case ah
	Case 0 'set video mode
        cols = 80 'for now, i'm just always using this for every screen mode.
        rows = 25 'although CGA graphics modes will be properly displayed by the video module.
        blankattr = 7
        vidmode = al
        Select Case al
        	Case &he4, &h30, &h20, &h6, &h5, &h4, &h3, 0
        	Case Else
        Screen 0
        Print "set video mode "+Hex$(al)+"h"
        End
        End Select
	Case 1 'set text-mode cursor shape
        'dont worry about it for now
    Case 2 'set cursor position
        cursx = dl
        cursy = dh
    Case 3 'get cursor position and size
        dh = cursy
        dl = cursx
    Case 5 'set active display page
        'dont worry about it for now
    Case 6 'scroll up window
        vidptr = videobase
        If al = 0 Then
            For y = 0 To rows - 1
                For x = 0 To cols - 1
                    RAM(vidptr) = 0
                    RAM(vidptr + 1) = blankattr
                    vidptr = vidptr + 2
                Next x
            Next y
            cursx = 0: cursy = 0
            cls
        End If
        UpdatedScreen = 1
    
	 Case 8 'read character and attribute at cursor position
    		ah = RAM(videobase + cursy*cols*2 + cursx*2 + 1)
    		al = RAM(videobase + cursy*cols*2 + cursx*2)
    
    Case 9 'write character and attribute at cursor position
        tempcalc = videobase + cursy * cols * 2 + cursx * 2
        For vidptr = tempcalc To tempcalc + (getreg16(cx) - 1) * 2 Step 2
            RAM(vidptr) = al
            RAM(vidptr + 1) = bl
            cursx = cursx + 1
            CheckCursorBounds
        Next vidptr

    Case &HA 'write character and attribute at cursor position
        tempcalc = videobase + cursy * cols * 2 + cursx * 2
        For vidptr = tempcalc To tempcalc + (getreg16(cx) - 1) * 2 Step 2
            RAM(vidptr) = al
            RAM(vidptr + 1) = 7 'bl
            cursx = cursx + 1
            CheckCursorBounds
        Next vidptr
	 	        
    Case &HE 'teletype output
        Select Case al
            Case 7
                Beep
            Case 8
                cursx = cursx - 1
        	Case 10
                cursy = cursy + 1                
            Case 13
                cursx = 0
            Case Else
                RAM(videobase + cols * cursy * 2 + cursx * 2) = al
                cursx = cursx Mod cols: cursy = cursy Mod rows
                cursx = cursx + 1
        End Select
        CheckCursorBounds
        Locate cursy+1, cursx+1
    
    Case &HF 'get current video mode
        ah = cols
        al = vidmode
        bh = 0
    
    Case &H12 'get blanking attribute
        bh = blankattr
	Case &hb
			cgabg = bl
    Case Else
        Screen 0: print "Unknown video interrupt 10h request!" + CrLf + "AX: " + Hex$(getreg16(ax))
        End
        ScreenRes 640, 400, 24
End Select
End Sub

Sub InitCGA()
Open "asciicga.dat" For Binary As #1
For n = 0 To 255
    a$ = Space$(128): Get #1, , a$
    m = 1
    For y = 0 To 15
        For x = 0 To 7
            FontCGA(n, x, y) = Asc(Mid$(a$, m, 1)): m = m + 1
        Next x
    Next y
Next n
Close #1

PaletteCGA(0) = 0
PaletteCGA(1) = RGB(0, 0, &HAA)
PaletteCGA(2) = RGB(0, &HAA, 0)
PaletteCGA(3) = RGB(0, &HAA, &HAA)
PaletteCGA(4) = RGB(&HAA, 0, 0)
PaletteCGA(5) = RGB(&HAA, 0, &HAA)
PaletteCGA(6) = RGB(&HAA, &H55, 0)
PaletteCGA(7) = RGB(&HAA, &HAA, &HAA)
PaletteCGA(8) = RGB(&H55, &H55, &H55)
PaletteCGA(9) = RGB(&H55, &H55, &HFF)
PaletteCGA(10) = RGB(&H55, &HFF, &H55)
PaletteCGA(11) = RGB(&H55, &HFF, &HFF)
PaletteCGA(12) = RGB(&HFF, &H55, &H55)
PaletteCGA(13) = RGB(&HFF, &H55, &HFF)
PaletteCGA(14) = RGB(&HFF, &HFF, &H55)
PaletteCGA(15) = RGB(&HFF, &HFF, &HFF)
End Sub

Sub InitVGA()
Open "asciivga.dat" For Binary As #1
For n = 0 To 255
    a$ = Space$(128): Get #1, , a$
    m = 1
    For y = 0 To 15
        For x = 0 To 7
            FontCGA(n, x, y) = Asc(Mid$(a$, m, 1)): m = m + 1
        Next x
    Next y
Next n
Close #1

PaletteCGA(0) = 0
PaletteCGA(1) = RGB(0, 0, &HAA)
PaletteCGA(2) = RGB(0, &HAA, 0)
PaletteCGA(3) = RGB(0, &HAA, &HAA)
PaletteCGA(4) = RGB(&HAA, 0, 0)
PaletteCGA(5) = RGB(&HAA, 0, &HAA)
PaletteCGA(6) = RGB(&HAA, &H55, 0)
PaletteCGA(7) = RGB(&HAA, &HAA, &HAA)
PaletteCGA(8) = RGB(&H55, &H55, &H55)
PaletteCGA(9) = RGB(&H55, &H55, &HFF)
PaletteCGA(10) = RGB(&H55, &HFF, &H55)
PaletteCGA(11) = RGB(&H55, &HFF, &HFF)
PaletteCGA(12) = RGB(&HFF, &H55, &H55)
PaletteCGA(13) = RGB(&HFF, &H55, &HFF)
PaletteCGA(14) = RGB(&HFF, &HFF, &H55)
PaletteCGA(15) = RGB(&HFF, &HFF, &HFF)
End Sub

Sub CheckCursorBounds()
        If cursx < 0 Then cursx = 0
        If cursy < 0 Then cursy = 0
        If cursx = cols Then cursx = 0: cursy = cursy + 1:
        If cursy = rows Then
            cursy = cursy - 1
            For temp1 = videobase + cols * 2 To videobase + cols * 2 * rows - 1
                RAM(temp1 - cols * 2) = RAM(temp1)
            Next temp1
            For temp1 = videobase + cols * 2 * (rows - 1) To videobase + cols * 2 * rows - 1
                If (temp1 And 1) = 1 Then RAM(temp1) = blankattr Else RAM(temp1) = 0
            Next temp1
        End If
End Sub

Sub VidRefresh()
Dim vidptr, curpixel As UInteger
Select Case vidmode
	Case 6
	For y = 1 To 400
    	For x = 1 To 640
    		charx = (x-1)
    		chary = (y-1)\2
  			vidptr = &hb8000 + (chary * 80) + (charx \ 8)
    		curpixel = RAM(vidptr)
    		Select Case charx Mod 8
    			Case 7: curpixel = curpixel And 1
    			Case 6: curpixel = (curpixel\2) And 1
    			Case 5: curpixel = (curpixel\4) And 1
    			Case 4: curpixel = (curpixel\8) And 1
    			Case 3: curpixel = (curpixel\16) And 1
    			Case 2: curpixel = (curpixel\32) And 1
    			Case 1: curpixel = (curpixel\64) And 1
    			Case 0: curpixel = (curpixel\128) And 1
    		End Select
    		PSet (x, y), PaletteCGA(curpixel*7)
    	Next x
	Next y

	Case 4,5
	For y = 1 To 400
    	For x = 1 To 640
    		charx = (x-1)\2
    		chary = (y-1)\2
  			vidptr = &hb8000 + ((chary\2) * 80) + ((chary Mod 2) * 8192) + (charx \ 4)
    		curpixel = RAM(vidptr)
    		Select Case charx Mod 4
    			Case 3: curpixel = curpixel And 3
    			Case 2: curpixel = (curpixel\4) And 3
    			Case 1: curpixel = (curpixel\16) And 3
    			Case 0: curpixel = (curpixel\64) And 3
    		End Select
    		Select Case curpixel
    			Case 0: curpixel = cgabg
    			Case 1: curpixel = 3
    			Case 2: curpixel = 5
    			Case 3: curpixel = 7
    		End Select
    		PSet (x, y), PaletteCGA(curpixel)
    	Next x
	Next y
	
	Case Else
	For y = 1 To 400
    	For x = 1 To 640
        	charx = (x - 1) \ 8
        	chary = (y - 1) \ 16
        	vidptr = videobase + chary * 160 + charx * 2
        	curchar = RAM(vidptr)
        	curpixel = FontCGA(curchar, (x - 1) Mod 8, (y - 1) Mod 16)
        	If curpixel = 0 Then curpixel = PaletteCGA((RAM(vidptr + 1) \ 16) And 7) Else curpixel = PaletteCGA(RAM(vidptr + 1) And 15)
        	charx = x - 1: chary = y - 1
        	PSet (charx, chary), RGB((curpixel \ 65536) And 255, (curpixel \ 256) And 255, curpixel And 255)
    	Next x
	Next y
End Select
End Sub
